#include<iostream>
#include<string>
using namespace std;

struct Zamestnanec
{
	string jmeno;
	string prijmeni;
	unsigned int plat;

	string jmenoAPrijmeni()
	{
		// plat = 1000;
		// return jmeno + " " + prijmeni;
		return this->jmeno + " " + this->prijmeni;
	}

	void vypis()
	{
		cout << "metoda: ";
		//cout << jmenoAPrijmeni() << " " << plat << endl;
		cout << this->jmenoAPrijmeni() << " " << this->plat << endl;
		//cout << jmeno << " " << prijmeni << " " << plat << endl;
	}

};

void vypis(const Zamestnanec &z)
{
	cout << "funkce: ";
	cout << z.jmeno << " " << z.prijmeni << " " << z.plat << endl;
}

class Zamestnanec1
{
	//private:
	string jmeno = "";
	string prijmeni = "";
	unsigned int plat = 10000;
	string jmenoAPrijmeni() const
	{
		// return jmeno + " " + prijmeni;
		return this->jmeno + " " + this->prijmeni;
	}
public:
	void nastavJmeno(const string& _jmeno) // setName
	{
		jmeno = _jmeno;
	}
	void nastavPrijmeni(const string& prijmeni)
	{
		this->prijmeni = prijmeni;
	}
	void nastavPlat(unsigned int plat)
	{
		if (plat < 10000 || plat > 50000)
			return;
		//this->plat = 10000;
		else
			this->plat = plat;
	}
	string vratJmeno() const // getName
	{
		return jmeno;
	}
	string vratprijmeni() const // getName
	{
		return prijmeni;
	}

	void vypis() const
	{
		cout << "metoda: ";
		//cout << jmenoAPrijmeni() << " " << plat << endl;
		cout << this->jmenoAPrijmeni() << " " << this->plat << endl;
		//cout << jmeno << " " << prijmeni << " " << plat << endl;
	}
	friend void vypis(const Zamestnanec1 &z);
	friend float premie(const Zamestnanec1 &z)
	{
		return z.plat *0.1;
	}
	friend class Zamestnanec2;

};

void vypis(const Zamestnanec1 &z)
{
	cout << "funkce: ";
	cout << z.jmenoAPrijmeni() << " " << z.plat << endl;
}

class Zamestnanec2
{
	string jmeno = "";
	string prijmeni = "";
	unsigned int plat = 0;
	string jmenoAPrijmeni();

public:
	void vypis();
};

string Zamestnanec2::jmenoAPrijmeni()
{
	// plat = 1000;
	// return jmeno + " " + prijmeni;
	return this->jmeno + " " + this->prijmeni;
}

void Zamestnanec2::vypis()
{
	cout << "metoda: ";
	//cout << jmenoAPrijmeni() << " " << plat << endl;
	cout << this->jmenoAPrijmeni() << " " << this->plat << endl;
	//cout << jmeno << " " << prijmeni << " " << plat << endl;
}

int main()
{
	const Zamestnanec1 a;
	a.vypis();
	vypis(a);
	cout << premie(a) << endl;

	Zamestnanec1 vera;
	vera.vypis();
	vera.nastavJmeno("Vera");
	vera.nastavPlat(0);
	vera.vypis();
	cout << vera.vratJmeno() << " " << vera.vratprijmeni() << endl;

	Zamestnanec pepa;
	pepa.jmeno = "Pepa";
	pepa.prijmeni = "Novak";
	pepa.plat = 45000;
	vypis(pepa);
	pepa.vypis();

	Zamestnanec *u;
	u = &pepa;
	vypis(*u);
	u->vypis();

	u = new Zamestnanec;
	u->jmeno = "Jana";
	u->prijmeni = "Nova";
	u->plat = 10000;
	vypis(*u);
	u->vypis();

	delete u;

	return 0;
}